Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/RecordPersonsArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/RecordPersonsArea.java	(revision 0)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/RecordPersonsArea.java	(revision 7)
@@ -0,0 +1,168 @@
+/*
+ * Authors: Matthieu Decorde
+ * 
+ * COPYRIGHT 2015 ICAR - CCC
+ * 
+ * This software is free software: you can redistribute it 
+ * and/or modify it under the terms of the GNU General Public
+ * License as published by the Free Software Foundation,
+ * either version 2 of the License, or (at your option) any
+ * later version.
+ * 
+ * This software is distributed in the hope that it will be
+ * useful, but WITHOUT ANY WARRANTY; without even the implied
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ * PURPOSE. See the GNU General Public License for more
+ * details.
+ * 
+ */
+package org.ccc.bcccc.client.areas;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.ccc.bcccc.client.areas.fields.PersonRecordField;
+import org.ccc.bcccc.client.panels.EditPanel;
+
+import com.google.gwt.user.client.ui.Label;
+import com.smartgwt.client.types.TitleOrientation;
+import com.smartgwt.client.util.SC;
+import com.smartgwt.client.util.ValueCallback;
+import com.smartgwt.client.widgets.Button;
+import com.smartgwt.client.widgets.form.DynamicForm;
+import com.smartgwt.client.widgets.form.fields.FormItem;
+import com.smartgwt.client.widgets.form.fields.PickerIcon;
+import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
+import com.smartgwt.client.widgets.form.fields.SelectItem;
+import com.smartgwt.client.widgets.form.fields.StaticTextItem;
+import com.smartgwt.client.widgets.form.fields.TextItem;
+import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
+import com.smartgwt.client.widgets.form.fields.events.FormItemIconClickEvent;
+import com.smartgwt.client.widgets.layout.HLayout;
+import com.smartgwt.client.widgets.layout.VLayout;
+
+
+// TODO: Auto-generated Javadoc
+/**
+ * The Class StringRecordField.
+ */
+public class RecordPersonsArea extends VLayout {
+
+
+
+	/** The name. */
+	String name;
+
+	/** The items. */
+	ArrayList<PersonRecordField> items = new ArrayList<PersonRecordField>();
+	
+	/** The panel. */
+	protected EditPanel panel;
+
+	/** The form. */
+	DynamicForm form;
+
+	/**
+	 * Instantiates a new string record field.
+	 *
+	 * @param panel the panel
+	 * @param name the name
+	 * @param multiple the multiple
+	 * @param freeField the free field
+	 * @param values the values
+	 */
+	public RecordPersonsArea(EditPanel panel) {
+		this.panel = panel;
+		this.name = "Personnes impliquées";
+
+		this.addMember(new Label(name));
+		
+		Button addButton = new Button("Ajouter une personne impliquée");
+		this.addMember(addButton);
+		addButton.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler() {
+			
+			@Override
+			public void onClick(com.smartgwt.client.widgets.events.ClickEvent event) {
+				addAField();
+			}
+		});
+		
+		this.setWidth100();
+
+		addAField();
+	}
+
+	/**
+	 * Adds the a field.
+	 */
+	public void addAField() {
+		
+		//String lname = name.toLowerCase().replace(" ", "");
+		PersonRecordField field = new PersonRecordField(this, name);
+		this.addMember(field); // add the new field item
+		
+	}
+
+	/**
+	 * Adds the default pickers.
+	 *
+	 * @param field the field
+	 * @param editPicker the edit picker
+	 */
+	protected void addDefaultPickers(FormItem field, PickerIcon editPicker) {
+		field.setIcons(editPicker);
+	}
+
+	/**
+	 * Gets the value.
+	 *
+	 * @return the value
+	 */
+	public String getValue() {
+		if (items.size() > 0) {
+			return items.get(0).getValue();
+		}
+		return "";
+	}
+
+	/**
+	 * Gets the values as string array.
+	 *
+	 * @return the values as string array
+	 */
+	public ArrayList<String> getValuesAsStringArray() {
+		ArrayList<String> ret = new ArrayList<String>();
+		for (PersonRecordField item : items) {
+			ret.add(item.getValue());
+		}
+		return ret;
+	}
+
+	/**
+	 * Sets the can edit.
+	 *
+	 * @param v the new can edit
+	 */
+	public void setCanEdit(boolean v) {
+		if (form != null)
+			form.setCanEdit(v);
+	}
+
+	/**
+	 * Sets the values.
+	 *
+	 * @param values the new values
+	 */
+	public void setValues(List<String> values) {
+		for (int i = 0 ; i < values.size() ; i++) {
+			if (items.size() <= i) addAField();
+			items.get(i).setValue(values.get(i));
+		}
+	}
+
+	public void removeAField(PersonRecordField personRecordField) {
+		items.remove(personRecordField);
+		this.removeMember(personRecordField);
+		personRecordField.destroy();
+	}
+}
\ No newline at end of file

Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/PublicationsRecordArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/PublicationsRecordArea.java	(revision 6)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/PublicationsRecordArea.java	(revision 7)
@@ -25,6 +25,7 @@
 import org.ccc.bcccc.client.panels.EditPanel;
 import org.ccc.bcccc.shared.Publication;
 
+import com.smartgwt.client.widgets.Button;
 import com.smartgwt.client.widgets.Label;
 import com.smartgwt.client.widgets.layout.VLayout;
 
@@ -47,9 +48,19 @@
 		this.setWidth100();
 		
 		Label title = new Label();
-		title.setContents("Publications");
+		title.setContents(name);
 		this.addMember(title);
 		
+		Button addButton = new Button("Ajouter une publication");
+		this.addMember(addButton);
+		addButton.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler() {
+			
+			@Override
+			public void onClick(com.smartgwt.client.widgets.events.ClickEvent event) {
+				addAField();
+			}
+		});
+		
 		addAField(); // create at least one entry
 	}
 
@@ -75,6 +86,11 @@
 	 * @param values the new publication values
 	 */
 	public void setValues(List<Publication> values) {
+		
+		while (fields.size() > values.size() ) {
+			this.remove(fields.get(0));
+		}
+		
 		int i = 0;
 		for (Publication d : values) {
 			if (fields.size() <= i) addAField();
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/ReportsRecordArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/ReportsRecordArea.java	(revision 6)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/ReportsRecordArea.java	(revision 7)
@@ -25,6 +25,7 @@
 import org.ccc.bcccc.client.panels.EditPanel;
 import org.ccc.bcccc.shared.Report;
 
+import com.smartgwt.client.widgets.Button;
 import com.smartgwt.client.widgets.Label;
 import com.smartgwt.client.widgets.layout.VLayout;
 
@@ -47,9 +48,19 @@
 		this.setWidth100();
 		
 		Label title = new Label();
-		title.setContents("Reports");
+		title.setContents(name);
 		this.addMember(title);
 		
+		Button addButton = new Button("Ajouter un rapport");
+		this.addMember(addButton);
+		addButton.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler() {
+			
+			@Override
+			public void onClick(com.smartgwt.client.widgets.events.ClickEvent event) {
+				addAField();
+			}
+		});
+		
 		addAField(); // create at least one entry
 	}
 
@@ -72,6 +83,11 @@
 	 * @param values the new values
 	 */
 	public void setValues(List<Report> values) {
+		
+		while (fields.size() > values.size() ) {
+			this.removeField(fields.get(0));
+		}
+		
 		int i = 0;
 		for (Report d : values) {
 			if (fields.size() <= i) addAField();
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DispositifsRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DispositifsRecordField.java	(revision 6)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DispositifsRecordField.java	(revision 7)
@@ -30,6 +30,7 @@
 import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
 import com.smartgwt.client.widgets.form.fields.SelectItem;
 import com.smartgwt.client.widgets.form.fields.StaticTextItem;
+import com.smartgwt.client.widgets.form.fields.TextItem;
 import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
 import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
 import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
@@ -54,7 +55,7 @@
 	SelectItem typeField;
 	
 	/** The url field. */
-	StaticTextItem urlField;
+	TextItem urlField;
 	
 	/** The mobile item. */
 	CheckboxItem mobileItem;
@@ -69,50 +70,23 @@
 		
 		this.area = area;
 		this.n = n;
-		this.setNumCols(8);
+		this.setNumCols(7);
 		
 		typeField = new SelectItem("dispname"+(n));
 		typeField.setValueMap(Dispositif.types);
 		typeField.setTitle("Type");
 
-		urlField = new StaticTextItem("dispurl"+(n));
+		urlField = new TextItem("dispurl"+(n));
 		urlField.setTitle("URL");
-		Picker EDIT = new Picker("pickers/edit.png");
-		PickerIcon urlEditPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
-			public void onFormItemClick(FormItemIconClickEvent event) { 
-				SC.askforValue("Enter the new value of URL of the dispositif", new ValueCallback() {
-					@Override
-					public void execute(String value) {
-						if (value != null) {
-							urlField.setValue(value);
-						}
-					}
-				});
-
-			}  
-		});
-		urlField.setIcons(urlEditPicker);
-
+		
 		mobileItem = new CheckboxItem("dispmobile"+(n));
 		mobileItem.setTitle("mobile");
 
-		ButtonItem addButton = new ButtonItem("dispadd"+n);
-		addButton.setTitle("+");
-		addButton.setStartRow(false);
-		addButton.setEndRow(true);
-
 		ButtonItem removeButton = new ButtonItem("dispremove"+n);
 		removeButton.setTitle("-");
 		removeButton.setStartRow(false);
 		removeButton.setEndRow(false);
 
-		addButton.addClickHandler(new ClickHandler() {
-			@Override
-			public void onClick(ClickEvent event) {
-				DispositifsRecordField.this.area.addAField();
-			}
-		});
-
 		removeButton.addClickHandler(new ClickHandler() {
 			@Override
 			public void onClick(ClickEvent event) {
@@ -120,7 +94,7 @@
 			}
 		});
 
-		this.setItems(typeField, urlField, mobileItem, removeButton, addButton);
+		this.setItems(typeField, urlField, mobileItem, removeButton);
 
 	}
 	
@@ -142,9 +116,11 @@
 	 */
 	public Dispositif getValue() {
 		r.type = typeField.getValueAsString();
+		
 		Object o = urlField.getValue();
 		if (o != null) r.url = urlField.getValue().toString();
 		else r.url = "";
+		
 		r.mobile = mobileItem.getValueAsBoolean();
 		return r;
 	}
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/TypeRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/TypeRecordField.java	(revision 0)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/TypeRecordField.java	(revision 7)
@@ -0,0 +1,46 @@
+package org.ccc.bcccc.client.areas.fields;
+
+import org.ccc.bcccc.client.areas.RecordTypesArea;
+
+import com.smartgwt.client.widgets.form.DynamicForm;
+import com.smartgwt.client.widgets.form.fields.PickerIcon;
+import com.smartgwt.client.widgets.form.fields.SelectItem;
+import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
+import com.smartgwt.client.widgets.form.fields.events.FormItemIconClickEvent;
+import com.smartgwt.client.widgets.layout.HLayout;
+
+public class TypeRecordField  extends HLayout {
+
+	/** The no. */
+	protected static int no = 1;
+	RecordTypesArea area;
+	final public String[] typesValues = {"privé", "commerce", "école", "etc."};
+	SelectItem field;
+	
+	public TypeRecordField(RecordTypesArea area, String name) {
+		this.area = area;
+		field = new SelectItem("person"+no++);
+		field.setValueMap(typesValues);
+		field.setShowTitle(false);
+		
+		PickerIcon removePicker = new PickerIcon(PickerIcon.CLEAR, new FormItemClickHandler() {  
+			public void onFormItemClick(FormItemIconClickEvent event) {  
+				TypeRecordField.this.area.remove(TypeRecordField.this);
+			}  
+		}); 
+
+		field.setIcons(removePicker);
+
+		DynamicForm form = new DynamicForm();
+		form.setFields(field);
+		this.addMember(form);
+	}
+	public String getValue() {
+		Object v = field.getValue();
+		if (v == null) return "";
+		return v.toString();
+	}
+	public void setValue(String v) {
+		field.setValue(v);
+	}
+}

Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/PersonRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/PersonRecordField.java	(revision 0)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/PersonRecordField.java	(revision 7)
@@ -0,0 +1,45 @@
+package org.ccc.bcccc.client.areas.fields;
+
+import org.ccc.bcccc.client.areas.RecordPersonsArea;
+
+import com.smartgwt.client.widgets.form.DynamicForm;
+import com.smartgwt.client.widgets.form.fields.PickerIcon;
+import com.smartgwt.client.widgets.form.fields.TextItem;
+import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
+import com.smartgwt.client.widgets.form.fields.events.FormItemIconClickEvent;
+import com.smartgwt.client.widgets.layout.HLayout;
+
+public class PersonRecordField  extends HLayout {
+
+	/** The no. */
+	protected static int no = 1;
+	RecordPersonsArea area;
+	
+	TextItem field;
+	public PersonRecordField(RecordPersonsArea area, String name) {
+		this.area = area;
+		
+		field = new TextItem("person"+no++);
+		field.setShowTitle(false);
+		
+		PickerIcon removePicker = new PickerIcon(PickerIcon.CLEAR, new FormItemClickHandler() {  
+			public void onFormItemClick(FormItemIconClickEvent event) {  
+				PersonRecordField.this.area.removeAField(PersonRecordField.this);
+			}  
+		}); 
+
+		field.setIcons(removePicker);
+
+		DynamicForm form = new DynamicForm();
+		form.setFields(field);
+		this.addMember(form);
+	}
+	public String getValue() {
+		Object v = field.getValue();
+		if (v == null) return "";
+		return v.toString();
+	}
+	public void setValue(String v) {
+		field.setValue(v);
+	}
+}

Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DataRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DataRecordField.java	(revision 6)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DataRecordField.java	(revision 7)
@@ -30,6 +30,7 @@
 import com.smartgwt.client.widgets.form.fields.SelectItem;
 import com.smartgwt.client.widgets.form.fields.StaticTextItem;
 import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
+import com.smartgwt.client.widgets.form.fields.TextItem;
 import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
 import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
 import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
@@ -54,7 +55,7 @@
 	SelectItem typeField;
 	
 	/** The url field. */
-	StaticTextItem urlField;
+	TextItem urlField;
 	
 	/**
 	 * Instantiates a new data record field.
@@ -65,54 +66,20 @@
 	public DataRecordField(DataRecordArea area, int n) {
 		this.area = area;
 		this.n = n;
-		this.setNumCols(6);
+		this.setNumCols(5);
 		
 		typeField = new SelectItem("datatype"+(n));
 		typeField.setValueMap(Data.values);
 		typeField.setTitle("Type");
 
-		urlField = new StaticTextItem("dataurl"+(n));
+		urlField = new TextItem("dataurl"+(n));
 		urlField.setTitle("URL");
-		urlField.addClickHandler(new ClickHandler() {
-			@Override
-			public void onClick(ClickEvent event) {
-				Window.open(urlField.getValue().toString(), typeField.getValueAsString(), "");
-			}
-		});
 		
-		Picker EDIT = new Picker("pickers/edit.png");
-		PickerIcon urlEditPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
-			@Override
-			public void onFormItemClick(FormItemIconClickEvent event) {
-				SC.askforValue("Enter the new value of URL of Data", new ValueCallback() {
-					@Override
-					public void execute(String value) {
-						if (value != null) {
-							urlField.setValue(value);
-						}
-					}
-				});
-			}  
-		});
-		urlField.setIcons(urlEditPicker);
-
-		ButtonItem addButton = new ButtonItem("dataadd"+n);
-		addButton.setTitle("+");
-		addButton.setStartRow(false);
-		addButton.setEndRow(true);
-
 		ButtonItem removeButton = new ButtonItem("dataremove"+n);
 		removeButton.setTitle("-");
 		removeButton.setStartRow(false);
 		removeButton.setEndRow(false);
 
-		addButton.addClickHandler(new ClickHandler() {
-			@Override
-			public void onClick(ClickEvent event) {
-				DataRecordField.this.area.addAField();
-			}
-		});
-
 		removeButton.addClickHandler(new ClickHandler() {
 			@Override
 			public void onClick(ClickEvent event) {
@@ -120,7 +87,7 @@
 			}
 		});
 
-		this.setFields(typeField, urlField, removeButton, addButton);
+		this.setFields(typeField, urlField, removeButton);
 	}
 
 	/**
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/PublicationRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/PublicationRecordField.java	(revision 6)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/PublicationRecordField.java	(revision 7)
@@ -29,6 +29,7 @@
 import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
 import com.smartgwt.client.widgets.form.fields.SelectItem;
 import com.smartgwt.client.widgets.form.fields.StaticTextItem;
+import com.smartgwt.client.widgets.form.fields.TextItem;
 import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
 import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
 import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
@@ -50,10 +51,10 @@
 	int n;
 
 	/** The user field. */
-	StaticTextItem userField;
+	TextItem userField;
 
 	/** The url field. */
-	StaticTextItem urlField;
+	TextItem urlField;
 
 	/** The type field. */
 	SelectItem typeField;
@@ -66,51 +67,25 @@
 	 */
 	public PublicationRecordField(PublicationsRecordArea publicationsRecordArea, int n) {
 
-		this.area = area;
+		this.area = publicationsRecordArea;
 		this.n = n;
-		this.setNumCols(8);
+		this.setNumCols(7);
 		
-		userField = new StaticTextItem("pubuser"+(n));
+		userField = new TextItem("pubuser"+(n));
 		userField.setTitle("User");
 
-		urlField = new StaticTextItem("puburl"+(n));
+		urlField = new TextItem("puburl"+(n));
 		urlField.setTitle("URL");
-		Picker EDIT = new Picker("pickers/edit.png");
-		PickerIcon nameEditPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
-			public void onFormItemClick(FormItemIconClickEvent event) { 
-				SC.askforValue("Enter the new value of URL of the publication ", new ValueCallback() {
-					@Override
-					public void execute(String value) {
-						if (value != null) {
-							urlField.setValue(value);
-						}
-					}
-				});
-			}  
-		});
-		urlField.setIcons(nameEditPicker);
-
+		
 		typeField = new SelectItem("pubtype"+(n));
 		typeField.setTitle("Type");
 		typeField.setValueMap(Publication.types);
 
-		ButtonItem addButton = new ButtonItem("pubadd"+n);
-		addButton.setTitle("+");
-		addButton.setStartRow(false);
-		addButton.setEndRow(false);
-
 		ButtonItem removeButton = new ButtonItem("pubremove"+n);
 		removeButton.setTitle("-");
 		removeButton.setStartRow(false);
 		removeButton.setEndRow(false);
 
-		addButton.addClickHandler(new ClickHandler() {
-			@Override
-			public void onClick(ClickEvent event) {
-				PublicationRecordField.this.area.addAField();
-			}
-		});
-
 		removeButton.addClickHandler(new ClickHandler() {
 			@Override
 			public void onClick(ClickEvent event) {
@@ -118,7 +93,7 @@
 			}
 		});
 
-		this.setItems(userField, urlField, typeField, removeButton, addButton);
+		this.setItems(userField, urlField, typeField, removeButton);
 
 	}
 
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/ReportRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/ReportRecordField.java	(revision 6)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/ReportRecordField.java	(revision 7)
@@ -30,6 +30,7 @@
 import com.smartgwt.client.widgets.form.fields.SpinnerItem;
 import com.smartgwt.client.widgets.form.fields.StaticTextItem;
 import com.smartgwt.client.widgets.form.fields.TextAreaItem;
+import com.smartgwt.client.widgets.form.fields.TextItem;
 import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
 import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
 import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
@@ -51,7 +52,7 @@
 	int n;
 	
 	/** The user item. */
-	StaticTextItem userField;
+	TextItem userField;
 	
 	/** The comment item. */
 	TextAreaItem commentField;
@@ -69,52 +70,25 @@
 
 		this.area = area;
 		this.n = n;
-		this.setNumCols(8);
+		this.setNumCols(7);
 		
-		Picker EDIT = new Picker("pickers/edit.png");
-
-		userField = new StaticTextItem("reportuser"+(n));
+		userField = new TextItem("reportuser"+(n));
 		userField.setTitle("User");
 				
 		commentField = new TextAreaItem("reportcomment"+(n));
 		commentField.setTitle("Comment");
-		PickerIcon nameEditPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
-			public void onFormItemClick(FormItemIconClickEvent event) { 
-				SC.askforValue("Enter the comment", new ValueCallback() {
-					@Override
-					public void execute(String value) {
-						if (value != null) {
-							commentField.setValue(value);
-						}
-					}
-				});
-			}  
-		});
-		commentField.setIcons(nameEditPicker);
-
+		
 		noteField = new SpinnerItem("reportnote"+(n));
 		noteField.setTitle("Note");
 		noteField.setMin(1);
 		noteField.setMax(5);
 		noteField.setValue(1);
 		
-		ButtonItem addButton = new ButtonItem("reportadd"+n);
-		addButton.setTitle("+");
-		addButton.setStartRow(false);
-		addButton.setEndRow(true);
-
 		ButtonItem removeButton = new ButtonItem("reportremove"+n);
 		removeButton.setTitle("-");
 		removeButton.setStartRow(false);
 		removeButton.setEndRow(false);
 
-		addButton.addClickHandler(new ClickHandler() {
-			@Override
-			public void onClick(ClickEvent event) {
-				ReportRecordField.this.area.addAField();
-			}
-		});
-
 		removeButton.addClickHandler(new ClickHandler() {
 			@Override
 			public void onClick(ClickEvent event) {
@@ -122,7 +96,7 @@
 			}
 		});
 		
-		this.setFields(userField, commentField, noteField, removeButton, addButton);
+		this.setFields(userField, commentField, noteField, removeButton);
 	}
 	
 	/**
@@ -152,6 +126,7 @@
 		else r.comment = "";
 		
 		r.note = Integer.parseInt(noteField.getValueAsString());
+		
 		return r;
 	}
 }
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/DocumentsRecordArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/DocumentsRecordArea.java	(revision 6)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/DocumentsRecordArea.java	(revision 7)
@@ -25,6 +25,7 @@
 import org.ccc.bcccc.client.panels.EditPanel;
 import org.ccc.bcccc.shared.DocumentUnit;
 
+import com.smartgwt.client.widgets.Button;
 import com.smartgwt.client.widgets.Label;
 import com.smartgwt.client.widgets.layout.VLayout;
 
@@ -51,6 +52,16 @@
 		title.setContents("Documents");
 		this.addMember(title);
 		
+		Button addButton = new Button("Ajouter un document");
+		this.addMember(addButton);
+		addButton.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler() {
+			
+			@Override
+			public void onClick(com.smartgwt.client.widgets.events.ClickEvent event) {
+				addAField();
+			}
+		});
+		
 		addAField(); // create at least one entry
 	}
 
@@ -76,6 +87,11 @@
 	 * @param values the new documentation values
 	 */
 	public void setValues(List<DocumentUnit> values) {
+		
+		while (fields.size() > values.size() ) {
+			this.remove(fields.get(0));
+		}
+		
 		int i = 0;
 		for (DocumentUnit d : values) {
 			if (fields.size() <= i) addAField();
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/RecordTypesArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/RecordTypesArea.java	(revision 0)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/RecordTypesArea.java	(revision 7)
@@ -0,0 +1,162 @@
+/*
+ * Authors: Matthieu Decorde
+ * 
+ * COPYRIGHT 2015 ICAR - CCC
+ * 
+ * This software is free software: you can redistribute it 
+ * and/or modify it under the terms of the GNU General Public
+ * License as published by the Free Software Foundation,
+ * either version 2 of the License, or (at your option) any
+ * later version.
+ * 
+ * This software is distributed in the hope that it will be
+ * useful, but WITHOUT ANY WARRANTY; without even the implied
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ * PURPOSE. See the GNU General Public License for more
+ * details.
+ * 
+ */
+package org.ccc.bcccc.client.areas;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.ccc.bcccc.client.areas.fields.PersonRecordField;
+import org.ccc.bcccc.client.areas.fields.TypeRecordField;
+import org.ccc.bcccc.client.panels.EditPanel;
+
+import com.google.gwt.user.client.ui.Label;
+import com.smartgwt.client.types.TitleOrientation;
+import com.smartgwt.client.util.SC;
+import com.smartgwt.client.util.ValueCallback;
+import com.smartgwt.client.widgets.Button;
+import com.smartgwt.client.widgets.form.DynamicForm;
+import com.smartgwt.client.widgets.form.fields.FormItem;
+import com.smartgwt.client.widgets.form.fields.PickerIcon;
+import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
+import com.smartgwt.client.widgets.form.fields.SelectItem;
+import com.smartgwt.client.widgets.form.fields.StaticTextItem;
+import com.smartgwt.client.widgets.form.fields.TextItem;
+import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
+import com.smartgwt.client.widgets.form.fields.events.FormItemIconClickEvent;
+import com.smartgwt.client.widgets.layout.HLayout;
+import com.smartgwt.client.widgets.layout.VLayout;
+
+
+// TODO: Auto-generated Javadoc
+/**
+ * The Class StringRecordField.
+ */
+public class RecordTypesArea extends VLayout {
+
+
+
+	/** The name. */
+	String name;
+
+	/** The items. */
+	ArrayList<TypeRecordField> items = new ArrayList<TypeRecordField>();
+	
+	/** The panel. */
+	protected EditPanel panel;
+
+	/**
+	 * Instantiates a new string record field.
+	 *
+	 * @param panel the panel
+	 * @param name the name
+	 * @param multiple the multiple
+	 * @param freeField the free field
+	 * @param values the values
+	 */
+	public RecordTypesArea(EditPanel panel) {
+		this.panel = panel;
+		this.name = "Types";
+		this.setWidth100();
+		
+		this.addMember(new Label(name));
+		
+		Button addButton = new Button("Ajouter un type");
+		this.addMember(addButton);
+		addButton.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler() {
+			
+			@Override
+			public void onClick(com.smartgwt.client.widgets.events.ClickEvent event) {
+				addAField();
+			}
+		});
+
+		addAField();
+	}
+
+	/**
+	 * Adds the a field.
+	 */
+	public void addAField() {
+		
+		TypeRecordField field = new TypeRecordField(this, name);
+		items.add(field); // add the new field item
+		this.addMember(field);
+	}
+
+	/**
+	 * Adds the default pickers.
+	 *
+	 * @param field the field
+	 * @param editPicker the edit picker
+	 */
+	protected void addDefaultPickers(FormItem field, PickerIcon editPicker) {
+		field.setIcons(editPicker);
+	}
+
+	/**
+	 * Gets the value.
+	 *
+	 * @return the value
+	 */
+	public String getValue() {
+		if (items.size() > 0) {
+			Object v = items.get(0).getValue();
+			if (v == null) v = "";
+			return v.toString();
+		}
+		return "";
+	}
+
+	/**
+	 * Gets the values as string array.
+	 *
+	 * @return the values as string array
+	 */
+	public ArrayList<String> getValuesAsStringArray() {
+		ArrayList<String> ret = new ArrayList<String>();
+		for (TypeRecordField item : items) {
+			ret.add(item.getValue());
+		}
+		return ret;
+	}
+
+	/**
+	 * Sets the values.
+	 *
+	 * @param values the new values
+	 */
+	public void setValues(List<String> values) {
+		
+		while (items.size() > values.size() ) {
+			this.remove(items.get(0));
+		}
+		
+		for (int i = 0 ; i < values.size() ; i++) {
+			if (items.size() <= i) addAField();
+			items.get(i).setValue(values.get(i));
+		}
+	}
+
+	public void remove(TypeRecordField typeRecordField) {
+		if (items.remove(typeRecordField)) {
+			this.removeMember(typeRecordField);
+			typeRecordField.destroy();
+		}
+	}
+}
\ No newline at end of file

Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/StringRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/StringRecordField.java	(revision 6)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/StringRecordField.java	(revision 7)
@@ -33,6 +33,7 @@
 import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
 import com.smartgwt.client.widgets.form.fields.SelectItem;
 import com.smartgwt.client.widgets.form.fields.StaticTextItem;
+import com.smartgwt.client.widgets.form.fields.TextItem;
 import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
 import com.smartgwt.client.widgets.form.fields.events.FormItemIconClickEvent;
 import com.smartgwt.client.widgets.layout.HLayout;
@@ -50,9 +51,6 @@
 	/** The Constant ADD. */
 	static final Picker ADD = new Picker("pickers/add.png");
 	
-	/** The Constant EDIT. */
-	static final Picker EDIT = new Picker("pickers/edit.png");
-
 	/** The name. */
 	String name;
 	
@@ -118,21 +116,6 @@
 		field.setShowTitle((!multiple));
 		field.setTitle(name);
 
-		PickerIcon editPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
-			public void onFormItemClick(FormItemIconClickEvent event) { 
-				SC.askforValue("Enter the new value of "+name, new ValueCallback() {
-
-					@Override
-					public void execute(String value) {
-						if (value != null) {
-							field.setValue(value);
-						}
-					}
-				});
-
-			}  
-		}); 
-
 		if (multiple) {
 			PickerIcon removePicker = new PickerIcon(PickerIcon.CLEAR, new FormItemClickHandler() {  
 				public void onFormItemClick(FormItemIconClickEvent event) {  
@@ -152,9 +135,9 @@
 			if (values != null)
 				field.setIcons(removePicker, addPicker);
 			else 
-				field.setIcons(editPicker, removePicker, addPicker);
+				field.setIcons(removePicker, addPicker);
 		} else {
-			addDefaultPickers(field, editPicker);
+			//addDefaultPickers(field, editPicker);
 		}
 
 		items.add(field); // add the new field item
@@ -183,7 +166,7 @@
 			field = new SelectItem(lname+no++);
 			((SelectItem)field).setValueMap(values);
 		} else {
-			field = new StaticTextItem(lname+no++);
+			field = new TextItem(lname+no++);
 		}
 		return field;
 	}
@@ -195,7 +178,9 @@
 	 */
 	public String getValue() {
 		if (items.size() > 0) {
-			return items.get(0).getValueField();
+			Object v = items.get(0).getValue();
+			if (v == null) v = "";
+			return v.toString();
 		}
 		return "";
 	}
@@ -208,7 +193,9 @@
 	public ArrayList<String> getValuesAsStringArray() {
 		ArrayList<String> ret = new ArrayList<String>();
 		for (FormItem item : items) {
-			ret.add(item.getValueField());
+			Object v = item.getValue();
+			if (v == null) v = "";
+			ret.add(v.toString());
 		}
 		return ret;
 	}
@@ -223,7 +210,8 @@
 			itemsVector[i] = items.get(i);
 			//System.out.println(" "+items.get(i).getName());
 		}
-		form.setItems(itemsVector);
+		if (form != null)
+			form.setItems(itemsVector);
 	}
 
 	/**
@@ -232,7 +220,8 @@
 	 * @param v the new can edit
 	 */
 	public void setCanEdit(boolean v) {
-		form.setCanEdit(v);
+		if (form != null)
+			form.setCanEdit(v);
 	}
 
 	/**
